(** This file initializes a number of modules needed for the safety proof. *)

Require Export Metatheory.

Require Export Arith.
Require Export Decidable.
Require Export List.
Require Export Relations_3_facts.

Require Export actions.
Require Export buffers.
Require Export data_race_free.
Require Export drf_language_axioms.
Require Export equivalence.
Require Export events.
Require Export indexes.
Require Export inherently_precedes.
Require Export list_facts.
Require Export locks.
Require Export model_facts.
Require Export models.
Require Export nat_facts.
Require Export sequential_consistency.
Require Export subtraces.
Require Export types.
Require Export var_map.
Require Export write_buffering.

Declare Module L : LANGUAGE_MODEL.
Module SC := Sequential_Consistency L.
Declare Module L_SC : SYSTEM_MODEL L SC.
Module WB := Write_Buffering L.
Declare Module L_WB : SYSTEM_MODEL L WB.
Module DRF := DataRaceFree L SC L_SC.
Module LFacts := LanguageModelFacts L.
Module SCMMFacts := MemoryModelFacts L SC.
Module WBMMFacts := MemoryModelFacts L WB.
Module SCFacts := ModelFacts L SC L_SC.
Module WBFacts := ModelFacts L WB L_WB.
Declare Module Typ : TYPE_MODEL with Module L := L.
Declare Module Pres : TYPE_MODEL_PRESERVATION
  with Module L := L with Module Typ := Typ.
Declare Module L_Axioms : DRF_LANGUAGE_AXIOMS
  with Module L := L with Module Typ := Typ with Module Pres := Pres.
